
## The Tas Log Tree

Tas can prints the task name and the values of arguments with indent, and the logs in tasks is printed with the indent of tasks, which visualizes the modules structure and helps us to debug the app.

![](./__res/log-tree.png)

Try it:
```bash
$ cd /path/to/tas
$ node examples/usage/3.log-tree/complex/index.test.js
```

　

## How To Use



#### Print Tas log tree in all modules

Just enable Tas tree only once in main js file. This will makes Tas in all modules printing log tree automatically. Like below:
```js
// Enable printing log tree
tas.enableTree();
```

Try it:

```bash
$ cd /path/to/tas
$ node examples/demo/easy-asynchronization/index.js
```

　

#### Print Tas log tree in some module

Sometimes we only need to print Tas log tree in some module, so we should enable it in the following way, and then disable it at the ending of the module to avoid affect the other modules. For example: 

```js
tas(function(){
  
    // Enable printing log tree in this module.
    tas.enableTree();
});

...

tas(function(){

    // Disable printing log tree to avoid affect the other modules.
    tas.disableTree();
});
```

Try it:

```bash
$ cd /path/to/tas
$ node examples/usage/3.log-tree/simple/index.js
$ node examples/usage/3.log-tree/complex/index.js
```

　

#### Print logs with indent of log tree

Recommend to set log as tas.log before use it.

```js
var log = tas.log;

tas(function(){
    log('wait...');

    setTimeout(function(){
        log('continue...');

        tas.next();
    }, 0);
});
```

Try it:

```bash
$ cd /path/to/tas
$ node examples/usage/3.log-tree/simple/index.js
```

　

#### Print log tree with header and footer in submodule

First, tas.load() will add task to Tas queue. Then, tas.load() will add tasks for printing log tree with header and footer if log tree is enabled. That's means, tas.load() is equivalent to tas() if log tree is disabled.

```js
var tas = require('tas');
var a;

var tasks = function(){
    a = 0;

    tas(function(){
        a ++;
      
        // Go to the next task.
        tas.next();
    });
};

var exports = {
    do: function(){

        // If you want to print log tree with header
        // and footer in submodule, use tas.load().
        // Otherwise, just use tas() still.
        tas.load(tasks);
    }
};

module.exports = exports;
```

Try it:

```bash
$ cd /path/to/tas
$ node examples/usage/3.log-tree/complex/index.js
```

