# The Performance of Tas

Tas can performs more than **1 million** async tasks per second. With Tas, we can write server code with clear structure and excellent performance in Node.js.

　

## Tas vs Promise

Clone the Tas repo first (if you have not done it yet):

```bash
$ git clone https://github.com/tasjs/tas.git
$ cd tas
$ npm install
```

Run the following:
```bash
$ cd /path/to/tas
$ node benchmark/tas-vs-promise.js
```

The results are as follows (depending on your Node.js version):

　

#### In Node.js 8
![](./__res/tas-vs-promise-in-node.js-v8.png)

　

#### In Node.js 7
![](./__res/tas-vs-promise-in-node.js-v7.png)

　

#### In Node.js 6
![](./__res/tas-vs-promise-in-node.js-v6.png)

　

#### In Node.js 5
![](./__res/tas-vs-promise-in-node.js-v5.png)

　

#### In Node.js 4
![](./__res/tas-vs-promise-in-node.js-v4.png)

　

## Tas.next() vs tas.pass()

Tas.pass2() is faster than tas.pass(), and tas.pass() is faster than tas.next(). [See details](../go-to-the-next-task/index.md)

![](./__res/tas.next-vs-tas.pass.png)

Try it:

```bash
$ cd /path/to/tas
$ node benchmark/tas.js
```

　

### About Validity

Yes, the above tests looks so good. But how can we prove that the results are correct? Well, see  [Execution Order](../execution-order/index.md) and  [Concurrency Order](../execution-order/concurrency-order.md) for more details.

　

### About Benchmark

The above tests are based on [OYO](https://github.com/hiowenluke/oyo), it's a benchmark for concurrent performance of Node.js app, strongly recommend it.
