/**
 * Tester of examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tester = {
	check: function(describe, tas, exp, val){
		var result, count;

		({
			test: function(){
				result = exp === val ? 'ok' : 'x';
				count = tas.count = typeof tas.count === 'undefined' ? 1 : tas.count + 1;
				count = ('00' + count).substr(-2);
				return this;
			},

			printLog: function(){
				var info = '---- %s // %s -- should return %s' + (result === 'x' ? ' instead of %s' : '');
				result === 'ok' && (val = '');

				console.log(info, result, describe, exp, val);
				return this;
			},

			onFailed: function(){
				result === 'x' && tas.abort();
				return this;
			}

		}).test().printLog().onFailed();
	},

	emit: function(test, times){
		times = times || 3;

		var count = 0;
		var handler = setInterval(function(){
			++ count === times && clearInterval(handler);

			(function(count){
				test(count);
			})(count);

		}, 0);
	}
};

module.exports = tester;
