/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

// Use .begin() at the beginning of main js file (in this case, it is this file).
// It is not necessary for submodules.
var tas = require('../tas').begin();
var a;

var tasks = function(){

	a = 0;

	tas(function(){
		a ++; // 1
		tas.next();
	});

	tas({
		t1: function(){
			a ++; // 2

			setTimeout(function(){
				a ++; // 3
				tas.next();
			}, 0);
		},

		t2: function(){
			a ++; // 4

			setTimeout(function(){
				a ++; // 5
				tas.next();
			}, 0);
		},

		t3: {
			t31: function(){
				a ++; // 6

				setTimeout(function(){
					a ++; // 7
					tas.next();
				}, 0);
			},

			t32: function(){
				a ++; // 8

				setTimeout(function(){
					a ++; // 9
					tas.next();
				}, 0);
			},
		}
	});

	tas(function(){
		a ++; // 10
		tas.next();
	});

	tas(function(){
		console.log(a); // 10

		// Use tas.end() at the ending of main js file.
		tas.end();
	});
};

tas(tasks);
