/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

// Use .begin() at the beginning of main js file (in this case, it is this file).
// It is not necessary for submodules.
var tas = require('../tas').begin();
var a;

var tasks = function(){

	a = 1;

	tas({
		t1: {
			t11: function(){
				a ++; // 2
				tas.next();
			},

			t12: function (){
				[1].forEach(function(){

					// Abort Tas, then the remaining tasks will be ignored.
					// So the value of a will be returned only once (when count is 2).
					tas.abort('abort');
				});
			},

			t13: function(){ // ignored
				a ++; // 3
				tas.next();
			},
		},

		t2: function (){ // ignored
			a ++; // 4
			tas.next();
		}
	});

	tas(function(){ // ignored
		a ++; // 5
		console.log(a);
		tas.next();
	});

	tas(function(){ // ignored

		// Use tas.end() at the ending of main js file.
		tas.end();
	});
};

tas(tasks);
