/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

// Use .begin() at the beginning of main js file (in this case, it is this file).
// It is not necessary for submodules.
var tas = require('../tas').begin();
var a;

var tasks = function(){

	a = 0;

	tas({
		t1: {
			t11: function(){
				a ++; // 1
				tas.next();
			},

			t12: function (){
				[1].forEach(function(){

					// The remaining task(s) in the current tasks will be ignored.
					// Note that it is only valid for the current object (in this case, it is "t1").
					// Just like the statement "break" can only quit the current loop.
					tas.break();
				});
			},

			t13: function(){ // ignored
				a ++;
				tas.next();
			},
		},

		t2: function (){
			a ++; // 2
			tas.next();
		}
	});

	tas(function(){
		a ++; // 3
		console.log(a);
		tas.next();
	});

	tas(function(){

		// Use tas.end() at the ending of main js file.
		tas.end();
	});
};

tas(tasks);
