/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

// Use .begin() at the beginning of main js file (in this case, it is this file).
// It is not necessary for submodules.
var tas = require('../tas').begin();
var log = tas.log;
var a;

var tasks = function(){

	a = 0;
	
	tas(function(){

		// Enable printing log tree in this module
		tas.enableTree();
		tas.next();
	});

	tas({
		t1: function(){
			a ++;

			log('wait...');
			setTimeout(function(){

				log('continue...');
				tas.next();
			}, 500);
		},

		t2: function(){
			a ++;
			tas.next();
		}
	});

	tas({
		t3: function(){
			a ++; // 3

			log('wait...');
			setTimeout(function(){
				a ++; // 4

				log('t4');
				log('continue...');

				tas.next();
			}, 500);
		},

		t5: function t5(){
			a ++; // 5
			tas.next();
		}
	});

	tas({
		t6: function(){
			a ++; // 6

			tas({
				t7: function(){
					a ++; // 7

					log('wait...');
					setTimeout(function(){

						log('continue...');
						tas.next();
					}, 500);
				},

				t8: function(){
					a ++; // 8
					tas.next();
				}
			});
		},

		t9: function(){
			a ++; // 9
			tas.next();
		}
	});

	tas({
		t10: function(){
			a ++; // 10
			tas.next();
		}
	});

	tas(function end(){
		console.log('a =', a); // 10

		// Disable printing log tree to avoid affect other modules.
		tas.disableTree();

		// Use tas.end() at the ending of main js file.
		tas.end();
	});
};

tas(tasks);
