/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('./tas').begin();
var m1 = require('./m1');
var m2 = require('./m2');

var tasks = function(){

	// Enable printing log tree.
	// This is valid for all modules.
	tas.enableTree();

	// Define the a as global variable for testing
	global.a = 0;

	tas({
		t1: function(){
			a ++; // 1

			m1.do();
			m2.do();

			tas(function t18(a0, a1, a2){ // 1, 2, 3 // received from t16_done() in "m2/index.js".
				a += a0; // 18
				a += a1; // 20
				a += a2; // 23

				tas.next([4, 5], {hi: 'hi'});
			});

			tas(function t19(arr, obj){ // [4,5], {hi: "hi"} // received from t18().
				arr.forEach(function(e){
					a += e; // 27 // 32
				});
				tas.next();
			});
		},

		t20: function(){
			tas.next();
		}
	});

	tas(function(){
		console.log('a =', a); // 32
		tas.end();
	});
};

tas(tasks);
