/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../../../tas');
var fs = require('fs');

var tasks = function(){

	//--------------------------------------------
	// An example of callback hell of async getting data, thanks to Scott Robinson:
	// http://stackabuse.com/avoiding-callback-hell-in-node-js/
	//--------------------------------------------

	//getData(function(a){
	//	getMoreData(a, function(b){
	//		getMoreData(b, function(c){
	//			getMoreData(c, function(d){
	//				getMoreData(d, function(e){
	//						...
	//				});
	//			});
	//		});
	//	});
	//});
	//--------------------------------------------

	// Let's use Tas to fix it.

	tas({
		t11: function t11(err, data){
			if (err) return tas.break(err);
			console.log(++ a); // 1

			fs.readFile(__filename, 'utf8', tas.next);
		},

		t12: function t12(err, data){
			if (err) return tas.break(err);
			console.log(++ a); // 2

			fs.readFile(__filename, 'utf8', tas.next);
		},

		t13: function t13(err, data){
			if (err) return tas.break(err);
			console.log(++ a); // 3

			fs.readFile(__filename, 'utf8', tas.next);
		}
	});

	tas(function t1end(err, data){
		tas.next();
	});
};

var exports = {
	do: function(){
		tas(tasks);
	}
};

module.exports = exports;
