/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../../tas');

var env = {};
var a;

var tasks = function(){
	if (env.count === 2) return tas.abort('abort at 2nd');

	a = 1;

	tas({
		t1: {
			t11: function(){
				a ++; // 2
				tas.next();
			},

			t12: function (){
				[1].forEach(function(){

					// Abort Tas, then the remaining tasks will be ignored.
					// So the value of a will be returned only once (when count is 2).
					tas.abort('abort');
				});
			},

			t13: function(){ // ignored
				a ++; // 3
				tas.next();
			},
		},

		t2: function (){ // ignored
			a ++; // 4
			tas.next();
		}
	});

	tas(function(){ // ignored
		a ++; // 5
		console.log(a);
		tas.next();
	});
};

var exports = {
	do: function(count){

		// Save the environment variables to this module.
		// Note that we should place this operation in a function and
		// join it into Tas queue, otherwise the environment variables
		// will be changed immediately instead of waiting for its turn.
		tas(function(){
			env.count = count;
			tas.next();
		});

		// Join the tasks to Tas queue.
		// Tas will perform it in the order we arranged
		// instead of running it immediately.
		tas(tasks);

		// For require(..).do()
		return this;
	},

	get: function(){
		return a; // 2
	}
};

module.exports = exports;
