/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tester = require('../../tester');
var test = function(count) {

	// Use .begin() at the beginning of main js file (in this case, it is this file).
	// It is not necessary for submodules.
	var tas = require('../../tas').begin();

	// Load submodule(s).
	// When count === 2, Tas will be aborted, the following test will be canceled. and run some task.
	var app = require('./app').do(count);

	// Run the test.
	// In submodule, Tas is aborted, so this test will print nothing.
	tas(function(){

		// Perform the method(s) of submodule(s)
		var val = app.get();
		var exp = 3;

		tester.check("2.breaking flow: tas.break()", tas, exp, val);
		tas.end();
	});
};

// Run three times.
tester.emit(test, 3);
