/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

'use strict';

const
	data = require('./data'),
	tasks = require('./tasks'),
	pass = require('./pass'),
	runner = require('./runner'),
	tree = require('../extensions/tree');

const
	flag = data.flag,
	ext = data.extensions;

const
	abort = {
	do(args){
		args.length && /* istanbul ignore next */ console.log.apply(null, args);

		// Set the flag isAbort for subsequent tasks.
		// Otherwise the subsequent tasks will be executed.
		// When the next "begin" tasks started, it will be restore to false.
		flag.isAbort = true;

		// Reset log tree if it is enabled.
		ext.isTreeEnabled && tree.reset();

		tasks.clearTheRemainingTasks();
		pass.reset();
		runner.next();
	}
};

module.exports.__proto__ = abort;
