/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

'use strict';

const
	nested = require('./nested'),
	util = require('./util'),
	submodule = require('./submodule');

const
	indent = {
	lastTreeIndent: 0,

	setIndent(val){
		this.lastTreeIndent = val;
	},

	getStr(isForLog){
		let level = this.lastTreeIndent + 1 + (isForLog ? 1 : 0);
		let indentStr = util.repeat(' ', (level - 1) * 4);
		let prefix = ('  ' + level).substr(-2) + '|';
		let str = prefix + indentStr;

		return submodule.insertModuleIndent(str);
	},

	reset(){
		this.lastTreeIndent = 0;
	}
};

module.exports.__proto__ = indent;
