/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

'use strict';

const
	data = require('../../core/data'),
	runner = require('../../core/runner');

const
	nested = {
	count: 0,

	add(){
		this.count ++;
	},

	sub(){
		this.count --;
	},

	getCount(){
		return this.count;
	},

	createFnForBegin(arr){
		let me = this;
		let fn = function(){
			me.add();
			process.nextTick(function(){
				runner.next();
			})
		};

		arr.push(fn);
	},

	createFnForEnd(arr){
		let me = this;
		let fn = function(){
			me.sub();
			process.nextTick(function(){
				runner.next();
			})
		};

		arr.push(fn);
	},

	createFnForAdd(fnName, arr, deep){
		let me = this;
		let fn = function(){
			me.add();
			process.nextTick(function(){
				runner.next();
			})
		};

		fn.treeIndent = this.getCount() + deep;
		fn.__label = fnName;

		arr.push(fn);
	},

	createFnForSub(arr, deep){
		let me = this;
		let fn = function(){
			!data.flag.isAwait && me.sub();
			process.nextTick(function(){
				runner.next();
			})
		};

		fn.treeIndent = this.getCount() + deep;

		arr.push(fn);
	},

	reset(){
		this.count = 0;
	}
};

module.exports.__proto__ = nested;
