/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

'use strict';

const
	data = require('../../core/data'),
	indent = require('./indent'),
	submodule = require('./submodule'),
	util = require('./util');

const print = {
	do(func){
		let funcName = func.__label || func.treeBranch || func.name || '<anonymous>';
		if (!funcName || funcName === 'fn') return;

		if (!func.__isHeader && !func.__isFooter) {
			let args = data.pass.isHasArgs ? data.pass : null;

			if (args) {
				let str = '';
				let maxLen = 120; // 1 line in mac os terminal

				args.forEach(function (arg) {
					typeof arg !== 'undefined' && (str += JSON.stringify(arg) + ', ');
				});

				str = str.replace(/, $/, '');
				str.length > maxLen && /* istanbul ignore next */ (str = str.substr(0, maxLen) + '...');

				funcName += ' \t// ' + str;
			}
		}

		this.printWithIndent(func, funcName);
	},

	printWithIndent(func, funcName){
		typeof func.treeIndent !== 'undefined' && indent.setIndent(func.treeIndent);
		util.log(submodule.getIndentStrWithModuleIndent(func), funcName);
	}
};

module.exports = print;
