/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

'use strict';

const
	logArray = require('./logArray');

const
	util = {
	log(){
		/* istanbul ignore if */
		if (global.isDisabledLog) return;

		let args = Array.prototype.slice.call(arguments);

		/* istanbul ignore else */
		if (logArray.isSaveToArr) {
			logArray.save(args[0] + ' ' + args[1]);
		}
		else {
			console.log.apply(console, args);
		}
	},

	repeat(str, times) {
		times < 0 && /* istanbul ignore next */ (times = 0);
		return new Array(times + 1).join(str);
	}
};

module.exports.__proto__ = util;
