/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

'use strict';

const
	runner = require('./core/runner'),
	units = require('./core/units'),
	tree = require('./extensions/tree');

const
	prepare = {
	do: function(Tas){
		this.loadExtensions(Tas);
		this.initCore(Tas);
	},

	loadExtensions: function(Tas){
		tree.init(Tas);
	},

	initCore: function(Tas){
		runner.init(Tas);
		units.init(Tas);
	}
};

module.exports = prepare;
