/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tester = require('../tester');
var expect = require('chai').expect;

describe('1.task_stream: tas.next()', function(){
	it('should return 19,18', function(done){

		var test = function(done, count){

			var tas = require('../tas').begin();
			var a = 1;

			tas({
				t1: function(){

					if (count === 1) {
						a ++; // 2
					}

					// Pass a parameter
					tas.next(1);
				},

				t2: function(a0){
					a += a0; // 3

					setTimeout(function(){

						// Pass multiple parameters
						tas.next(2, 3, 4);
					}, 0);
				},

				t3: function(a0, a1, a2){
					a += a0; // 5
					a += a1; // 8
					a += a2; // 12

					setTimeout(function(){

						// Pass an array parameter.
						var arr = [1, 2, 3];
						tas.next(arr);
					}, 0);
				}
			});

			tas({
				t1: function (arr){
					arr.forEach(function(e){
						a += e; // 18
					});

					setTimeout(function(){

						// Pass nothing, just go to the next task.
						tas.next();
					}, 0);
				},

				t2: function (){
					a ++; // 19
					tas.next();
				}
			});

			tas(function (){
				done(count, a);
				tas.end();
			});
		};

		var check = function(results){
			expect(results.toString() === '19,18').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
