/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tester = require('../tester');
var expect = require('chai').expect;

describe('1.task_stream: tas.pass2()', function(){
	it('should return 12,11', function(done){

		var test = function(done, count){

			var tas = require('../tas').begin();
			var a = 1;

			tas({
				t1: function(){
					a ++; // 2

					setTimeout(function(){
						if (count === 1) {
							a ++; // 3
						}

						var err = null;
						var data = 2;

						// Pass 2 parameters
						tas.pass2(err, data);
					}, 0);
				},

				t2: function(err, data){
					a += data; // 5

					setTimeout(function(){
						a ++; // 6

						// Pass a parameter
						tas.pass2(1);
					}, 0);
				},

				t3: function(a0){
					a += a0; // 7

					setTimeout(function(){

						// Pass multiple parameters.
						// Only the first two parameters are valid.
						tas.pass2(2, 3, 4);
					}, 0);
				}
			});

			tas({
				t1: function (a0, a1, a2){
					a += a0; // 9
					a += a1; // 12

					setTimeout(function(){

						// Pass nothing, just go to the next task.
						tas.pass2();
					}, 0);
				},

				t2: function (){
					tas.next();
				}
			});

			tas(function (){
				done(count, a);
				tas.end();
			});
		};

		var check = function(results){
			expect(results.toString() === '12,11').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
