/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tester = require('../tester');
var expect = require('chai').expect;

describe('2.breaking-flow: tas.abort()', function(){
	it('should return ,5', function(done){

		var test = function(done, count){

			var tas = require('../tas').begin();
			var a = 1;

			tas({
				t1: {
					t11: function(){
						a ++; // 2
						tas.next();
					},

					t12: function (){
						[1].forEach(function(){
							if (count === 1) {

								// Abort Tas, then the remaining tasks will be ignored.
								// So the value of a will be returned only once (when count is 2).
								tas.abort();
							}
							else {
								tas.next();
							}
						});
					},

					t13: function(){ // ignored when count === 1
						a ++; // 3
						tas.next();
					},
				},

				t2: function (){ // ignored when count === 1
					a ++; // 4
					tas.next();
				}
			});

			tas(function(){ // ignored when count === 1
				a ++; // 5
				tas.next();
			});

			tas(function (){ // ignored when count === 1
				done(count, a);
				tas.end();
			});
		};

		var check = function(results){
			expect(results.toString() === ',5').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
