/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tester = require('../tester');
var expect = require('chai').expect;

describe('2.breaking-flow: tas.break()', function(){
	it('should return 4,5', function(done){

		var test = function(done, count){

			var tas = require('../tas').begin();
			var a = 1;

			tas({
				t1: {
					t11: function(){
						a ++; // 2
						tas.next();
					},

					t12: function (){
						[1].forEach(function(){
							if (count === 1) {

								// The remaining task(s) in the current tasks will be ignored.
								tas.break();
							}
							else {
								tas.next();
							}
						});
					},

					t13: function(){ // ignored when count === 1
						a ++; // 3
						tas.next();
					},
				},

				t2: function (){
					a ++; // 4
					tas.next();
				}
			});

			tas(function(){
				a ++; // 5
				tas.next();
			});

			tas(function (){
				done(count, a);
				tas.end();
			});
		};

		var check = function(results){
			expect(results.toString() === '4,5').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
