/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

// Use .begin() at the beginning of main js file (in this case, it is this file).
// It is not necessary for submodules.
var tas = require('../../tas').begin();

// Load submodule(s).
var app = require('./app');

// Do something.
tas(function(){

	// Perform the method of submodule.
	// Note that there is a tas.next() at the ending of app.do(),
	// so here we should not put a tas.next() once again.
	app.do();
});

// Use tas.end() at the ending of main js file.
// Note that we should put tas.end() in a function,
// and add it to Tas queue instead of running it immediately.
tas(function(){
	tas.end();
});
