/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tester = require('../tester');
var expect = require('chai').expect;

var r1 = [];

describe('3.log-tree: tas.enableTree(), tas.disableTree(), tas.log()', function(){
	it('should create tree logs', function(done){

		var test = function(done, count) {

			var tas = require('../tas').begin();
			var app = require('./simple/app').do(count);

			tas(function (){
				done(count, app.get());
				tas.end();
			});
		};

		var check = function(results){
			expect(results.toString() === ',' + r1.join('\n')).to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});

r1 = [
	' 1| t1',
	' 2|     t2',
	' 3|         t3',
	' 4|             wait...',
	' 4|             t4',
	' 4|             continue...',
	' 3|         t5',
	' 3|         t6',
	' 4|             t7',
	' 4|             t8',
	' 3|         t9',
	' 3|         t10',
	' 2|     t11',
	' 2|     t12',
	' 2|     t13',
	' 2|     t14',
	' 3|         t15',
	' 3|         t16',
	' 2|     t17',
	' 2|     t18',
	' 1| t19',
	' 1| t20',
	' 1| t21',
	' 2|     t22',
	' 3|         t23',
	' 4|             t24',
	' 4|             t25',
	' 3|         t26',
	' 2|     t27',
	' 3|         t28',
	' 3|         t29',
	' 2|     t30',
	' 2|     t31',
	' 1| t32',
	' 2|     wait...',
	' 2|     t33',
	' 2|     continue...',
	' 1| t34',
	' 1| t35',
	' 1| t36',
	' 2|     t37',
	' 3|         t38',
	' 4|             wait...',
	' 4|             t39',
	' 4|             continue...',
	' 3|         t40',
	' 3|         t41',
	' 4|             wait...',
	' 4|             t42',
	' 4|             continue...',
	' 3|         t43',
	' 3|         t44',
	' 3|         t45',
	' 4|             wait...',
	' 4|             t46',
	' 4|             continue...',
	' 3|         t47',
	' 2|     t48',
	' 2|     t49',
	' 1| t50',
	' 1| t51',
	' 1| <anonymous>'
];
