/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../../tas');
var log = tas.log;

var env = {};
var a;
var timeout = 0;

var tasks = function(){
	if (env.count === 1) return tas.abort();

	a = 0;

	// Prepare
	tas(function(){

		// Enable printing log tree in this module.
		tas.enableTree();

		// Save logs into an array instead of printing it immediately.
		tas.logArray.begin();

		tas.next();
	});

	tas({
		t1: function(){
			a ++; // 1

			tas({
				t2: function(){
					a ++; // 2

					tas({
						t3: function(){
							a ++; // 3

							log('wait...');
							setTimeout(function(){
								a ++; // 4

								log('t4');
								log('continue...');

								tas.next();
							}, timeout);
						},

						t5: function t5(){
							a ++; // 5
							tas.next();
						}
					});

					tas({
						t6: function(){
							a ++; // 6

							tas({
								t7: function(){
									a ++; // 7
									tas.next();
								},

								t8: function(){
									a ++; // 8
									tas.next();
								}
							});

						},

						t9: function(){
							a ++; // 9
							tas.next();
						}
					});

					tas({
						t10: function(){
							a ++; // 10
							tas.next();
						}
					});
				},

				t11: function(){
					a ++; // 11
					tas.next();
				},

				t12: function(){
					a ++; // 12
					tas.next();
				}
			});

			tas({
				t13: function(){
					a ++; // 13
					tas.next();
				},

				t14: function(){
					a ++; // 14

					tas({
						t15: function(){
							a ++; // 15
							tas.next();
						},

						t16: function(){
							a ++; // 16
							tas.next();
						}
					});
				},

				t17: function(){
					a ++; // 17
					tas.next();
				}
			});

			tas({
				t18: function(){
					a ++; // 18
					tas.next();
				}
			});
		},

		t19: function(){
			a ++; // 19
			tas.next();
		}
	});

	tas(function t20(){
		a ++; // 20
		tas.next();
	});

	tas({
		t21: function(){
			a ++; // 21

			tas({
				t22: function() {
					a ++; // 22

					tas({
						t23: function(){
							a ++; // 23

							tas({
								t24: function(){
									a ++; // 24
									tas.next();
								},

								t25: function(){
									a ++; // 25
									tas.next();
								}
							});
						},

						t26: function(){
							a ++; // 26
							tas.next();
						}
					});
				}
			});

			tas({
				t27: function(){
					a ++; // 27

					tas({
						t28: function(){
							a ++; // 28
							tas.next();
						},

						t29: function(){
							a ++; // 29
							tas.next();
						}
					});
				}
			});

			tas({
				t30: function(){
					a ++; // 30
					tas.next();
				}
			});

		}
	});

	tas(function t31(){
		a ++; // 31
		tas.next();
	});

	tas({
		t32: function(){
			a ++; // 32

			log('wait...');
			setTimeout(function(){
				a ++; // 33

				log('t33');
				log('continue...');

				tas.next();
			}, timeout);
		},

		t34: function(){
			a ++; // 34
			tas.next();
		}
	});

	tas(function t35(){
		a ++; // 35
		tas.next();
	});

	tas({
		t36: function(){
			a ++; // 36

			tas({
				t37: function(){
					a ++; // 37

					tas({
						t38: function(){
							a ++; // 38

							log('wait...');
							setTimeout(function(){
								a ++; // 39

								log('t39');
								log('continue...');

								tas.next();
							}, timeout);
						}
					});

					tas(function t40(){
						a ++; // 40
						tas.next();
					});

					tas({
						t41: function(){
							a ++; // 41

							log('wait...');
							setTimeout(function(){
								a ++; // 42

								log('t42');
								log('continue...');

								tas.next();
							}, timeout);
						},

						t43: function(){
							a ++; // 43
							tas.next();
						}
					});

					tas(function t44(){
						a ++; // 44
						tas.next();
					});

					tas({
						t45: function(){
							a ++; // 45

							log('wait...');
							setTimeout(function(){
								a ++; // 46

								log('t46');
								log('continue...');

								tas.next();
							}, timeout);
						},

						t47: function(){
							a ++; // 47
							tas.next();
						}
					});
				},

				t48: function(){
					a ++; // 48
					tas.next();
				}
			});

			tas(function t49(){
				a ++; // 49
				tas.next();
			});
		},

		t50: function(){
			a ++; // 50
			tas.next();
		}
	});

	tas({
		t51: function(){
			a ++; // 51
			tas.next();
		}
	});

	// The end
	tas(function(){

		// Disable printing log tree to avoid affect the other modules.
		tas.disableTree();

		tas.next();
	});
};

var exports = {
	do: function(count){

		// Save the environment variables to this module.
		// Note that we should place this operation in a function and
		// join it into Tas queue, otherwise the environment variables
		// will be changed immediately instead of waiting for its turn.
		tas(function(){
			env.count = count;
			tas.next();
		});

		// Join the tasks to Tas queue.
		// Tas will perform it in the order we arranged
		// instead of running it immediately.
		tas(tasks);

		// For require(..).do()
		return this;
	},

	get: function(){

		// Get logs from array and convert to string.
		return tas.logArray.getStr();
	}
};

module.exports = exports;