/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../../tas');

var env = {};
var a;

var tasks = function(){
	if (env.count === 1) return tas.abort();

	a = 0;

	tas(function(){
		a ++; // 1
		tas.next();
	});

	tas({
		t1: function(){
			a ++; // 2

			setTimeout(function(){
				a ++; // 3
				tas.next();
			}, 0);
		},

		t2: function(){
			a ++; // 4

			setTimeout(function(){
				a ++; // 5
				tas.next();
			}, 0);
		},

		t3: {
			t31: function(){
				a ++; // 6

				setTimeout(function(){
					a ++; // 7
					tas.next();
				}, 0);
			},

			t32: function(){
				a ++; // 8

				setTimeout(function(){
					a ++; // 9
					tas.next();
				}, 0);
			},
		}
	});

	tas(function(){
		a ++; // 10
		tas.next();
	});
};

var exports = {
	do: function(count){

		// Save the environment variables to this module.
		// Note that we should place this operation in a function and
		// join it into Tas queue, otherwise the environment variables
		// will be changed immediately instead of waiting for its turn.
		tas(function(){
			env.count = count;
			tas.next();
		});

		// Join the tasks to Tas queue.
		// Tas will perform it in the order we arranged
		// instead of running it immediately.
		tas(tasks);

		// For require(..).do()
		return this;
	},

	get: function(){
		return a; // 10
	}
};

module.exports = exports;
