/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../../tas');
var m1 = require('./modules/async-getting-data');
var m2 = require('./modules/async-file-operation');
var env = {};

// Define a global variable for testing
global.a = 0;

var tasks = function(){
	if (env.count === 1) return tas.abort();

	global.a = 0;

	m1.do();
	m2.do();
};

var exports = {
	do: function(count){

		// Save the environment variables to this module.
		// Note that we should place this operation in a function and
		// join it into Tas queue, otherwise the environment variables
		// will be changed immediately instead of waiting for its turn.
		tas(function(){
			env.count = count;
			tas.next();
		});

		// Join the tasks to Tas queue.
		// Tas will perform it in the order we arranged
		// instead of running it immediately.
		tas(tasks);

		// For require(..).do()
		return this;
	},

	get: function(){
		return a; // 7
	}
};

module.exports = exports;
