/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tester = require('../tester');
var expect = require('chai').expect;

describe('5.more: tas.abort() when log tree is enabled', function(){
	it('should return ,1', function(done){

		var test = function(done, count){

			var tas = require('../tas').begin();
			var a = 0;

			tas(function(){
				tas.enableTree();
				tas.logArray.begin();

				tas.next();
			});

			tas({
				t1: function (){
					[1].forEach(function(){
						if (count === 1) {

							// Abort Tas, then the remaining tasks will be ignored.
							// So the value of a will be returned only once (when count is 2).
							tas.abort();
						}
						else {
							tas.next();
						}
					});
				},

				t2: function (){ // ignored when count === 1
					a ++;
					tas.next();
				}
			});

			tas(function (){ // ignored when count === 1
				done(count, a);
				tas.disableTree();
				tas.end();
			});
		};

		var check = function(results){
			expect(results.toString() === ',1').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
