/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */
var tester = require('../tester');
var expect = require('chai').expect;

var r1 = [];

describe('5.more: tas.load() when log tree is disabled', function(){

	it('should create tree logs', function(done){

		var test = function(done, count) {

			var tas = require('../tas').begin();
			var a = 0;

			var tasks = function(){
				if (count === 1) {
					a ++;
				}

				tas.next();
			};

			tas.load(tasks);

			tas(function(){
				done(count, a);
				tas.end();
			});
		};

		var check = function(results){
			expect(results.toString() === '1,0').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});

