/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */
var tester = require('../tester');
var expect = require('chai').expect;

var r1 = [];

describe('5.more: tas.pass() when pass 2 parameters', function(){

	it('should create tree logs', function(done){

		var test = function(done, count) {

			var tas = require('../tas').begin();
			var a = 0;

			tas(function(){
				if (count === 1) {
					a ++; // 1
				}

				setTimeout(function(){
					tas.pass(0, 1);
				}, 0)
			});

			tas(function(a0, a1){
				a += a0; // 1
				a += a1; // 2
				tas.next();
			});

			tas(function (){
				done(count, a);
				tas.end();
			});
		};

		var check = function(results){
			expect(results.toString() === '2,1').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});

